    ###########################################################################
    # >> Author:     Monday (Luke Robinson)                                   #
    # >> Contact:    jlukerobi AT gmail DOT com                               #
    #                                                                         #
    #           This addon is released under the "Artistic License"           #
    #              (http://dev.perl.org/licenses/artistic.html)               #
    #                                                                         #
    ###########################################################################
'''
    ###########################################################################
    # >> Thanks:                                                              #
    ###########################################################################
    #                                                                         #
    #    > RAC:                                                               #
    #    =================================================================    #
    #                  I would like to thank everyone at RAC                  #
    #            (www.relaxandchill.org), for being patient while I           #
    #           took my sweet time reading this.  I am not going to           #
    #            lie.. I could have finished this much sooner, but            #
    #             instead I thought throwing my dog's poo into the            #
    #            neighbor's open car window was more entertaining.            #
    #                                                                         #
    #    > GG Dev Team:                                                       #
    #    =================================================================    #
    #          As always, I want to thank the GG Dev team!  You guys          #
    #           are a fantastic group to work with, and I am glad to          #
    #                             be apart of it!                             #
    #                                                                         #
    #    > Mars and Murrie:                                                   #
    #    =================================================================    #
    #           These were the 2 founders of the m&ms candy company,          #
    #             several bags of peanut m&ms were consumed in the            #
    #                          making of this addon.                          #
    #                                                                         #
    ###########################################################################


    ###########################################################################
    # >> Credits:                                                             #
    ###########################################################################
    #                                                                         #
    #    > bonbon:                                                            #
    #    =================================================================    #
    #           Credit to bonbon for the disco ball idea.  I did not          #
    #           use any of her code in this addon, but I believe she          #
    #              deserves credit for comming up with the idea.              #
    #                                                                         #
    #                                                                         #
    #    > GG Dev Team:                                                       #
    #    =================================================================    #
    #         Since I am nesting this addon into gungame 5.1, I think         #
    #           they (we) deserved to be credited for hard work and           #
    #                               dedication!                               #
    #                                                                         #
    #                                                                         #
    #    > Schubaal:                                                          #
    #    =================================================================    #
    #           I only wrote this addon to fill the hole left behind          #
    #            when knifep3n stopped working because of updates.            #
    #          Thank you for your time and effort, and I wish you the         #
    #                                 best. :)                                #
    #                                                                         #
    ###########################################################################


    ###########################################################################
    # >> Special message to other coders:                                     #
    ###########################################################################
    #       If you act like a jackass and try to take part of this code       #
    #          without crediting me, I will hunt you down and shove a         #
    #                   sharpened pencil into your urethra.                   #   
    ###########################################################################
'''

'''
    TO DO:
        add translations
        work with elimination 
'''

# =============================================================================
# >> IMPORTS
# =============================================================================
# Python imports
import os
from path import path
from random import choice
from random import randint
from random import random
from random import shuffle

# Eventscripts imports
import es
import popuplib
import repeat
import weaponlib
import gamethread
from cmdlib import unregisterSayCommand
from cmdlib import registerSayCommand
from effectlib import drawCircle
from effectlib import drawLine
from playerlib import getPlayer
from playerlib import getUseridList



# Gungame imports
from gungame51.core.addons.shortcuts import AddonInfo
from gungame51.core.addons.shortcuts import AddonManager
from gungame51.core.messaging.shortcuts import centermsg
from gungame51.core.messaging.shortcuts import saytext2
from gungame51.core.players.shortcuts import Player



# =============================================================================
# >> ADDON REGISTRATION/INFORMATION
# =============================================================================
info = AddonInfo()
info.name = 'monday_knife'
info.title = "Monday's Knife Mod"
info.author = 'Monday (GG Dev Team)'
info.version = '1.38a'
# removed as we want it to run with elimination and with deathmatch(eventually) and we use
# deathmatch in the startup round...
#info.conflicts = ['gg_deathmatch', 'gg_elimination']
info.translations = ['monday_knife']


# =============================================================================
# >> GLOBAL VARIABLES
# =============================================================================

# Public Version Var
es.ServerVar('monday_knife_ver', info.version, info.title).makepublic()

# Server Vars
eventscripts_gamedir        = es.ServerVar('eventscripts_gamedir')
gg_multi_level              = es.ServerVar("gg_multi_level")
m_disco_index               = es.ServerVar('m_disco_index')
monday_knife_beacon         = es.ServerVar('monday_knife_beacon')
monday_knife_bonus          = es.ServerVar('monday_knife_bonus')
monday_knife_bots           = es.ServerVar('monday_knife_bots')
monday_knife_chicken        = es.ServerVar('monday_knife_chicken')
monday_knife_color          = es.ServerVar('monday_knife_color')
monday_knife_disco          = es.ServerVar('monday_knife_disco')
monday_knife_dir            = es.ServerVar('monday_knife_dir')
monday_knife_force          = es.ServerVar('monday_knife_force')
monday_knife_laser          = es.ServerVar('monday_knife_laser')
monday_knife_limit          = es.ServerVar('monday_knife_limit')
monday_knife_list           = es.ServerVar('monday_knife_list')
monday_knife_punish_lvl     = es.ServerVar('monday_knife_punish_lvl')
monday_knife_punish_speed   = es.ServerVar('monday_knife_punish_speed')
monday_knife_shuffle        = es.ServerVar('monday_knife_shuffle')
monday_knife_teleport       = es.ServerVar('monday_knife_teleport')
monday_knife_time           = es.ServerVar('monday_knife_time')
monday_knife_type           = es.ServerVar('monday_knife_type')
# Corvette911 addition to work with elimination

corvette_elimination 	    = es.ServerVar('gg_elimination')
corvette_debug         	    = es.ServerVar('corvette_debug_monday_knife')

#Assign the serve variables to a local variable.
#gg_elimination_spawn = 1 gungame will work normaly =0 will prevent respawn
gg_elimination_spawn 	    = es.ServerVar('gg_elimination_spawn')
# signals that gg_elimination is checking 1sec delay to respawn players
knife_allowed               = es.ServerVar('knife_allowed_CVAR')
# signals that a respawn is going to occur due to tk or suicide
tk_suicide_counter          = es.ServerVar('tk_suicide_counter_CVAR')

# Dictionaries
award = {
    'bonus': 0,
    'punish': 0 
}

kdisco = {
    'axis': (),
    'error': False,
    'loc': ()
}

menu = {
    'list': [], 
    'no': [], 
    'pop': None, 
    'started': False,
    'yes': []
}

misc = {
    'after_round': False,
    'can_kill': [],
    'cmd_list': [],
    'rounds': 0
}

song = {
    'full_list': [],
    'fulldir': '', 
    'last': '', 
    'list': [], 
    'playdir': ''
}

tele = {
    'loc': ('','',''), 
    'retry': False,
    'userid': '' 
}

# Repeater (This is done at the bottom of the script)
repeater = None

# Laser counter
lasers = 0


# Lists for laser effects
"""

    ### NOTE:
    ### Commented out because of possible server crashes.
    ### (Leaving here for future reference)

model_list = [
    'sprites/lgtning.vmt', 
    'materials/sprites/laser.vmt',
    'sprites/crystal_beam1.vmt',
    'materials/sprites/physbeam.vmt',
    'sprites/bluelight1.vmt' 
]

halo_list = [
    'sprites/lgtning.vmt', 
    'materials/sprites/halo01.vmt',
    'materials/sprites/blueglow1.vmt',
    'sprites/crystal_beam1.vmt',
    'materials/sprites/physbeam.vmt',
    'sprites/bluelight1.vmt',
    'materials/sprites/laser.vmt',
    'materials/sprites/sprite_fire01.vmt'      
]
"""
    

# =============================================================================
# >> LOAD & UNLOAD
# =============================================================================
def load():
    global test_in_progress
    song['fulldir'] = get_song_directories('full_dir') 
    song['playdir'] = get_song_directories('sub_dir')
    
    # Get sound lists
    set_sound_list()

    # Download sounds
    download()

    # Register say command
    registerSayCommand('!knife', knife_cmd, '!knife')
    registerSayCommand('!kfmenu', knife_cmd, '!kfmenu')

    # Register the kill command to prevent it from being used during fights.
    es.addons.registerClientCommandFilter(kill_filter)
    
    # Menu
    make_menu()
    
    test_in_progress = 0

    # Debug message
    es.dbgmsg(0, 'Loaded: %s' % info.name)
#    debugging_stuff()

def unload():
    # Clean up
    clean_fight()

    # Delete the repeater
    if repeater != None:
        repeater.delete()  

    # Delete popup
    menu['pop'].delete()

    # Unregister the kill command
    es.addons.unregisterClientCommandFilter(kill_filter)

    # Unregister !knife
    unregisterSayCommand('!knife')
    unregisterSayCommand('!kfmenu')

    # Debug message
    es.dbgmsg(0, 'Unloaded: %s' % info.name)
    
# =============================================================================
# >> GAME EVENTS
# =============================================================================
def player_spawn(event_var):
    userid = event_var['userid'] 
    
    # Spawn during knife fight?
    if repeater.status() == 2 and userid not in menu['yes']:
        # Put the player on the can kill list
        if userid not in misc['can_kill']:
            misc['can_kill'].append(userid)
        
        # Kill them
        es.server.queuecmd('es_xsexec %s kill' % userid)                 
        
        # Let them know why they died.
        ggPlayer = Player(userid)
        ggPlayer.saytext2(get_index(userid), 'LateSpawn', {}, True)

    # Give award?
    elif userid == award['bonus'] and int(monday_knife_bonus):        
        ggPlayer.saytext2(get_index(userid), 'SpeedBonus', {}, True)            
        pPlayer = getPlayer(userid)
        pPlayer.speed += .10
        
    # Punish for suicide
    elif userid == award['punish']:
        
        ggPlayer = Player(userid)        
        # Slow the guy down?
        if int(monday_knife_punish_speed):
            ggPlayer.saytext2(get_index(userid), 'SlowDown', {}, True)            
            pPlayer = getPlayer(userid)
            pPlayer.speed -= .15
            
        # Level the guy down?
        if int(monday_knife_punish_lvl):          
            
            # Can level down normally
            if (int(ggPlayer.level) - int(monday_knife_punish_lvl)) >= 1:  
                ggPlayer.leveldown(int(monday_knife_punish_lvl), 
                                                            userid, 'suicide')
            
            # Can only level down to 1
            else:
                ggPlayer.leveldown((int(ggPlayer.level)-1), 
                                                            userid, 'suicide')
            
            # Public Message
            saytext2('#human', get_index(userid), 'LevelDown', 
                                            {'name': es.getplayername(userid), 
                                 'level': int(monday_knife_punish_lvl)}, True)            

def round_end(event_var):
    clean_fight()
    menu['started'] = False
    misc['after_round'] = True
    global lasers
    
    # Display laser count
    if lasers:
        saytext2('#human', get_index(es.getuserid()), 'Lasers', 
                                                      {'lasers': lasers}, True)
    # Reset laser count
    lasers = 0

def round_start(event_var):
    if misc['rounds'] <= 2:
       misc['rounds'] += 1
    
    saytext2('#human', get_index(es.getuserid()), 'Info', {}, True)
        
    menu['started'] = False
    misc['after_round'] = False
    misc['can_kill'] = []

def es_map_start(event_var):
    # Get sound directories
    song['fulldir'] = get_song_directories('full_dir') 
    song['playdir'] = get_song_directories('sub_dir')

    # Get new sound list
    set_sound_list()
    
    # Set downloads
    download()
    
    # Reset a few things ...
    misc['rounds'] = 1
    menu['started'] = False


###############################################################
def player_delayed_death(userid):
    # this routine get's called based on the required delay to recheck for a knife available fight
    # portion of player_death(event_var) with some minor changes
    global knife_allowed
    global tk_suicide_counter

    # eliminated checks as they passed first test to get here..

    # it is now after the round? we are 1.5 seconds latter..
    if misc['after_round']:

        return

        
    # is elimination in about to respawn someone
    if (knife_allowed > 0) or (tk_suicide_counter >0):
    
        #elimination is waiting going to respawn someone

        # second retry also failed...
        return


    
    # rerun the checks for number of players now that the time has expired for spawning
    # and regenerate the human list needed later in this function
        
    human_list = getUseridList('#alive, #human')     
    
    # Are there any human players alive? If not stop here
    if human_list == []:
        return 
        
    # If there is at least 1 player in CT
    if not len(getUseridList('#ct, #alive')) == 1:
        return 
    
    # If there is at least 1 player in T
    if not len(getUseridList('#t, #alive')) == 1:
        return 
            
    bot_list = getUseridList('#alive, #bot')

    # Are bots allowed? If not stop here
    if len(bot_list) and not int(monday_knife_bots):

        return
      
    # Corvette911 - or force stop respawn by setting the CVAR - gg_elimination_spawn 1
    gg_elimination_spawn.set(0)
    
    # Has the vote allready gone out?
    if (menu['yes'] + menu['list'] + menu['no']) != []:
        return 

    # Mark the voting as started
    menu['started'] = True

    # Force the fight?
    if int(monday_knife_force):
        menu['yes'] = human_list + bot_list
        knife_prep()     
        
    else:   
        # Set list
        menu['list'] = human_list    
        
        # Anwser for all bots
        menu['yes'] = bot_list

        # Remove the userids from the no command list
        for _userid in menu['list']:
            if _userid in misc['cmd_list']:
                cmd_reset(_userid)
        
        # Send menu to remaining players
        
        menu['pop'].send(menu['list'])   
   
   # Remove menu residue dead player may have left

    gamethread.delayed(0.50, menu['pop'].unsend, userid)

###############################################################

def player_death(event_var):
    global knife_allowed
    global tk_suicide_counter

    userid = int(event_var['userid'])
    

    # During a knife fight?
    if repeater.status() == 2: 
        
        es.msg('repeater status == 2', 0)        
        # Was the player knife fighting?
        if userid in menu['yes']:
            attacker = int(event_var['attacker']) 

            # Is the victim on the server?
            if es.exists('userid', userid) and userid != 0:
    
                # If the attacker is not "world or the userid of the victim, 
                # it is not a suicide
                if ((attacker == 0) or (attacker == userid)):
                    if not es.isbot(userid):
                        award['punish'] = userid
                    return
                    
                if attacker in menu['yes']:
                    award['bonus'] = attacker
                    return
                    
            # Victim not on server, stop here
            else:
                return
                
        # Player was slayed for being unlucky, stop here
        else:    
            return
    
    # Allow fights right now?
    if misc['rounds'] < 3:

        return

    # This happen after the round?
    if misc['after_round']:

        return
    
    # before testing how many players are around..check to see 
    # if elimination in about to respawn someone
    if (knife_allowed > 0) or (tk_suicide_counter >0):
    
        #elimination is possible waiting going to respawn someone
        # if the respawn is a spawn kill or a tk have to wait
        # for next death to do anything

    
        if (knife_allowed > 0) and (tk_suicide_counter == 0):

            # Wait 2 seconds and recheck if someone spawed after a player death and if the knifing can start..
            gamethread.delayed(2, player_delayed_death, userid)

        return
    
    #Still use delayed function call to give other program time to set the variables    
    # it retests the alowances in there...
    gamethread.delayed(2, player_delayed_death, userid)    
    

        
    
# =============================================================================
# >> CUSTOM/HELPER FUNCTIONS
# =============================================================================
def equip_player(userid):
    # Don't bother with the other checks on a .12 second delay
    if es.exists('userid', userid):
        es.server.queuecmd('es_xgive %s item_assaultsuit' % userid)
        es.server.queuecmd('es_xgive %s weapon_knife' % userid)
        es.server.queuecmd('es_xsexec %s use weapon_knife' % userid)   

def delay_slay(userid_list):
    # Nobody to slay?
    if userid_list == []:
        return
        
    x = ''
    
    # Filter the userid list
    for userid in userid_list:
        if not es.exists('userid', userid):
            continue 
            
        x += 'es_xsexec %s kill; ' % userid
            
    # Slay them
    if x != '':
        es.server.queuecmd(x)

# still need to debug and check this part            
def set_sound_list():
    # Clear the old list
    song['fulllist'] = []
    
   # Look for files in a directory?
    if not int(monday_knife_type):
       
        # Look in all the files in the directory
        for f in os.listdir(song['fulldir']):            
            
            # Pass if the file is the chicken file
            if str(monday_knife_chicken).strip() not in \
              ('', '0', 'None') and \
              f == str(monday_knife_chicken).strip():
                continue
            
            # Add the song to the full list
            if f.lower().endswith('.mp3') or f.lower().endswith('.wav'):
                song['fulllist'].append(f)
        
    # Use the provided list, instead of getting our files from the directory
    # (with file existance checking)
    else:
        song['fulllist'] = [x.strip() for x in 
                                              str(monday_knife_list).split(',') 
                        if os.path.isfile(song['fulldir'].joinpath(x.strip()))]                                            
    
    # Do we have any songs?
    if song['fulllist'] == []:
        song['list'] = []  
       
        return

    # Save the old list in case monday_knife_limit needs it
    if int(monday_knife_limit):
        _old_list = song['list'] 
    
    # Randomize?
    if int(monday_knife_shuffle):
        shuffle(song['fulllist'])
        song['list'] = song['fulllist'] 

        # Limit the song list?
        if int(monday_knife_limit):
            song['list'] = song['list'][:int(monday_knife_limit)]
            
        return             

    # Sort the list (To ensure consistancy for rotation)
    song['fulllist'].sort()

    # Start with the entire list for rotation mode
    song['list'] = song['fulllist']          
        
    # Limit the song list?
    if int(monday_knife_limit):  
        
        # Is the list too short to limit?
        if len(song['list']) <= int(monday_knife_limit):
            return
         
        # Are we missing the old list? (first load)
        if _old_list == []:
            song['list'] = song['list'][:int(monday_knife_limit)]
            return           
      
        # Is our index missing?
        if _old_list[-1] not in song['list']:
            
            # Remove the bad entry
            del _old_list[-1]
            
            # Reverse the list
            _old_list.reverse()

            # Loop through the old list backwards
            for _old in _old_list:
                
                # Is the file in the new list?
                if _old in song['list']:
                    
                    # Reverse the list back to normal
                    _old_list.reverse()
                    break
                    
            # If no old songs were in the new list, then start from scratch
            else:
                song['list'] = song['list'][:int(monday_knife_limit)]
                return                                      
        
        # Get the index of the next song in the list
        i = song['list'].index(_old_list[-1]) + 1         

       # Just restart the list if we were at the end of the master list
        if i == 0:
            song['list'] = song['list'][:int(monday_knife_limit)]
            return   

        # Set the list to play the next songs
        song['list'] = song['list'][i:(i + int(monday_knife_limit))]                                        
        
        # Is the list too short? 
        # (We hit the end of the list and need to add from the begining)
        if len(song['fulllist']) > len(song['list']) < int(monday_knife_limit):
                
            # Loop through the full list from the start
            for song_file in song['fulllist']:
                
                # Add the song if it isn't already added
                if song_file not in song['list']:
                    song['list'].append(song_file) 
                
                    # Is our list full yet?
                    if len(song['list']) == int(monday_knife_limit):
                        return

def cmd_reset(userid):
    if userid in misc['cmd_list']:
        misc['cmd_list'].remove(userid)        

def kill_filter(userid, args):
    # If command is not kill then allow it
    if len(args) and args[0].lower() not in ('kill', 'explode'):
        return 1

    # Is the player in the suicide list?
    if userid in misc['can_kill']:
        return 1

    # Are we knife fighting?
    if repeater.status() == 2:       
        pPlayer = getPlayer(userid)

        # Freeze them in place for being an asshole
        pPlayer.freeze = 1
        saytext2('#human', get_index(userid), 'KillCMD', {'name': es.getplayername(userid)}, True)
        return 0
    
    # Allow the kill command, this is not a knife fight!
    return 1

def knife_cmd(userid, args):
    if userid in menu['list']:
        menu['list'].remove(userid)
        menu['yes'].append(userid)
        knife_prep()
        
    elif userid in menu['no']:
        menu['no'].remove(userid)
        menu['yes'].append(userid)
        knife_prep()
        
    elif userid not in misc['cmd_list']:
        Player(userid).saytext2(get_index(userid), {}, 'NotYet', True)
        misc['cmd_list'].append(userid)
        gamethread.delayed(5, cmd_reset, userid)
        
    return         

def clean_fight():
    # Unsend all menus
    menu['pop'].unsend(getUseridList('#human'))
        
    # Clear saved lists
    menu['list'] = []
    menu['yes'] = []
    menu['no'] = []  
       
    
    # Make sure a fight is not currently active, if so then turn it off
    if repeater.status() == 2: 
        repeater.stop()
        
    # Cleanup disco ball
    if int(monday_knife_disco):
        if m_disco_index in es.createentitylist().keys():
            es.server.queuecmd('es_xremove %s' % m_disco_index)
            
    # Reset any errors the disco ball may have had
    kdisco['error'] = False
    
    # Reset teleporting retry
    tele['retry'] = False
    
    # Corvette911 - Turn elimination back on or reset spawn on of new players on join - gg_elimination_spawn 0 - gg_elimination 1
    gg_elimination_spawn.set(1)
    
def player_vote(userid, choice, name):
    # This happen after the round?
    if misc['after_round']:
        return

    # Accepting choices?
    if not menu['started']:
        return
    
    # Make sure they can vote
    if userid not in menu['list']:
        return
    
    pPlayer = getPlayer(userid)
        
    # Make sure the player isn't dead or a spec
    if pPlayer.isdead or es.getplayerteam(userid) not in (2, 3):        
        
        # Remove the userid from any/all menu lists
        menu['pop'].unsend(userid)
        
        if userid in menu['list']:
            menu['list'].remove(userid)
            
        if userid in menu['yes']:
            menu['yes'].remove(userid)
        
        return       

    # No
    if str(choice) == '2':
        menu['list'].remove(userid)
        
        if userid not in menu['no']:
            menu['no'].append(userid)
        
        # Player is a chicken?
        if str(monday_knife_chicken).strip() not in ('', '0', 'None'):
            es.emitsound('player', userid, '%s/%s' % (song['playdir'], str(monday_knife_chicken).strip()), 1.0, 1.0)
        
        # Send message about the chicken
        saytext2('#human', get_index(userid), 'Chicken', 
                            {'name': es.getplayername(userid)}, True)            
        
        # Send command message      
        Player(userid).saytext2(get_index(userid), 'Command', {}, True)    
    
    # Yes
    elif str(choice) == '1':
        menu['list'].remove(userid)
        menu['yes'].append(userid)

        # Send message
        saytext2('#human', get_index(userid), 'Agree', {'name': es.getplayername(userid)}, True)       

        knife_prep()           

    else:
        return
    
    menu['pop'].unsend(userid)

def get_index(userid):
    # added to fix a proble with error messages when last user quits from the server
    if userid != 0:    
    
        return getPlayer(userid).attributes['index']
      
    clean_fight()

def make_menu():
    menu['pop'] = popuplib.create('monday_knife')
    menu['pop'].addline(" Monday's Knife Mod")
    menu['pop'].addline(" Have a knife fight?")  
    menu['pop'].addline("------------------------------")
    menu['pop'].addline("->1. Yes, of course.. I am awesome.")
    menu['pop'].addline("->2. No, I am a cowardly weenie.")
    menu['pop'].addline("------------------------------")
    menu['pop'].select(1,player_vote)
    menu['pop'].select(2,player_vote)
    menu['pop'].menuselect = player_vote
    menu['pop'].timeout('view',30)
    menu['pop'].timeout('send',30)

def tele_prep(source=None):
    # This happen after the round?
    if misc['after_round']:
        return
    
    # Teleport prep    
    if int(monday_knife_teleport):
        shuffle(menu['yes'])
        for userid in menu['yes']:
            pPlayer = getPlayer(userid)
            if int(monday_knife_teleport) == 1:
                if pPlayer.onGround():
                    tele['userid'] = userid
                    tele['loc'] = pPlayer.getLocation()
                    kdisco['loc'] = tele['loc'] 
                    break
            
            else:
                tele['userid'] = userid
                tele['loc'] = pPlayer.getLocation()
                break                    
                
        else:
            tele['userid'] = None
            return
                                
        # Slap them across the map
        pPlayer.health = 5000
        pPlayer.push(randint(500,600), randint(250,350), 1)

def knife_prep():    
    # This happen after the round?
    if misc['after_round']:
        return

    # Make sure the fight isn't already running
    if repeater.status() == 2:
        return

    # Someone says no ?
    if menu['no'] != []:
        return
        
    # Someone still needs to vote ?
    if menu['list'] != []:
        return

    # Making sure there was at least 1 vote
    if menu['yes'] == []:
        return
        
    humans = getUseridList('#human, #alive') 
    
    # Make sure there is at least 1 human player    
    if not humans:
             
        return
    
    tele['retry'] = False
  
    # Teleport Prep
    tele_prep()                                

    # Stop multilevelers?
    if int(gg_multi_level):
        am = AddonManager()
        am.call_block(am.__loaded__['gg_multi_level'], 'stop_multi_levelers')
        # if more than 1v1 is to be used...a cvar exists to block multilevel from happening
        
    # remove all weapons moved here was done in loop in original version caused isues leaving gun for 1 sec
    for i in weaponlib.getIndexList('#all'):
            es.server.queuecmd('es_xremove %s' % i)
    
    # Disco ball prep
    #monday_knife_disco
    if int(monday_knife_disco):
        # Use disco timing (x10)
        d = 0.10
        	
        # Create ball
        es.server.queuecmd('es_xprop_dynamic_create %s roller.mdl' % humans[0])  

        # Get the index
        es.server.queuecmd('es_xcopy m_disco_index eventscripts_lastgive')
        
    # Use normal timing
    else:
        d = 1.0
    
    # Remove popup if leftover on anyone
    menu['pop'].unsend(getUseridList('#human'))
        
    gamethread.delayed(0.2, repeater.start, (d, ((int(monday_knife_time) + 4) / d)))

# still need to debug and check this part
def get_song_directories(dir_type):
    # Get the server var and clean it up
    _dir = str(monday_knife_dir).replace('\\', '/').strip()
    
    # Strip off any leading "/" 
    if _dir.startswith('/'):
        _dir = _dir[1:]
    
    # Strip off any trailing "/"
    if _dir.endswith('/'):
        _dir = _dir[:-1]
    
    # Just need the sub directory string?
    if dir_type == 'sub_dir':
        return _dir.strip()
    
    # Return the path instance?
    if dir_type == 'full_dir':
        return path('%s/sound/%s' % (str(eventscripts_gamedir).replace('\\', '/'), _dir))

# still need to debug and check this part seems to have worked at least once.. 
def download():
    # Temp list
    _temp = song['list'] 
    
    # Make chicken sound downloadable ?
    _chic = str(monday_knife_chicken).strip() 
    if _chic not in ('', '0', 'None') and \
      os.path.isfile(song['fulldir'].joinpath(_chic)):         
        _temp.append(_chic)     
        
    # Is the list empty?
    if _temp == []:
        return

    # Add files to downloadables
    for f in _temp:
        es.stringtable('downloadables', 'sound/' + '%s/%s' % (song['playdir'], f))

def colors():
    _color = [0]

    # Level 5
    color_selection = [25, 75, 125, 160, 205, 255]
        
    # Level 4
    if int(monday_knife_color) <= 4:
        color_selection.remove(50)
    
        # Level 3
        if int(monday_knife_color) <= 3:
            color_selection.remove(100)    
    
            # Level 2
            if int(monday_knife_color) <= 2:
                color_selection.remove(200)        
    
                # Level 1
                if int(monday_knife_color) <= 1:
                    color_selection.remove(150)
    
    # Pick a color, but ignore the dark ones
    _color = [choice(color_selection) for x in (1, 2, 3)]
 
    return _color

def teleport(userid_list):
    # This happen after the round?
    if misc['after_round']:
        return

    # Need new userid?
    if tele['userid'] == None:
        tele['retry'] = True
        tele_prep()
     
    # Teleport
    else:
        x, y, z = tele['loc']         
        x2, y2, z2 = es.getplayerlocation(tele['userid'])
        
        # Did the player move?
        if (abs(x-x2) + abs(y-y2)) <= 20:
            tele['retry'] = True
            tele_prep()    
        
        else:
            if userid_list[0] == tele['userid']:
                teleporter = userid_list[1]
            else:
                teleporter = userid_list[0]          
    
            es.server.queuecmd('es_xsetpos %s %s %s %s' % (teleporter, x, y, (z + 10)))
            tele['retry'] = False   

            # Pull the disco ball over to the players if needed, but only if 
            # we have an index
            if int(monday_knife_disco) > 0 and \
              str(m_disco_index) not in ('', '0', 'None'):      
                
                # Don't use teleport chords?
                if not int(monday_knife_teleport):
                    kdisco['loc'] = es.getplayerlocation(userid_list[0])
                
                # Add to get z height above the player's head
                x, y, z = kdisco['loc'] 
                z += 125
                
                kdisco['loc'] = tuple([x, y, z])
                
                # Set the ball location
                es.server.queuecmd('es_setindexprop server_var(m_disco_' + 'index) "CBaseEntity.m_vecOrigin" ' + '"%s"' % ','.join(map(str, [x, y, z])))
            
                        
# =============================================================================
# >> LOOP FUNCTION
# =============================================================================
# need to add display of time left on the screen see ro_knifefight for code as it works..
def knife_loop():   
    t_list = getUseridList('#alive, #t') 
    ct_list = getUseridList('#alive, #ct') 
    userid_list = ct_list + t_list
    
    # If humans are no around we need to stop!
    if len(t_list) != 1 or len(ct_list) != 1:
        repeater.stop()
        clean_fight()
        return

    count = repeater['count']
    timeleft = repeater['timeleft']
    interval = repeater['interval']

    # Get proper timing
    if int(monday_knife_disco):
        if (count % 10) == 0:
            on_second = True
        else:
            on_second = False
    else:
        on_second = True       
    
    ''' 
        ==========================
        > Teleport section
        ==========================
    ''' 
    
    # Need to teleport?
    if int(monday_knife_teleport):
        
        # Is this the first tick?
        if count == 1:
            teleport(userid_list)
        
        # Retry on the second?
        elif on_second and tele['retry']: 
                teleport(userid_list)

    
    
    ''' 
        ==========================
        > Final prep section
        ==========================
    ''' 

    # Go message
    if float(interval * count) == 4.0: 
        centermsg('#human', 'GoTime')     

    # Remove all weapons from map on first tick
    if count == 1:
 
        # Only play music if it is available
        if song['list'] != []:                 
            
            # Is this a new map or a reload?
            if song['last'] == '':
                song_file = song['list'][0]                                
            
            # Start over if the last song isnt in the current list
            elif song['last'] not in song['list']:
                song_file = song['list'][0]
                 
            # Is the last played song the last in the list?
            elif song['list'][-1] == song['last']:
                song_file = song['list'][0]             
            
            # Just move on to the next song, everything is normal.
            else:                          
                _last_index = song['list'].index(song['last'])                                 
                song_file = song['list'][(_last_index + 1)]                   

            # Set the last song played
            song['last'] = song_file

            # Play song from disco ball?
            if int(monday_knife_disco):
                es.emitsound('entity', str(m_disco_index),'%s/%s' % (song['playdir'], song_file), 1, 0)    
            
            # Emit it from a player
            else:
                es.emitsound('player', userid_list[1], '%s/%s' % (song['playdir'], song_file)) 

    # 3 secs or under
    if float(interval * count) <= 3.0 and on_second:
        es.emitsound('player', userid_list[0], 'hl1/fvox/beep.wav', 1, 0)
        es.centermsg((4-int(interval * count)))
        

    # 3 seconds exact
    if float(interval * count) == 3.0:
        tele['retry'] = False  
        
        # Give players back basic equitment
        for player in userid_list:
            pPlayer = getPlayer(player)
            pPlayer.set('health', '100')
            gamethread.delayed(0.12, equip_player, player)
                               
    
    
    ''' 
        ==========================
        > Stop section
        ==========================
    '''     
    # Should we play the countdown beep?
    if timeleft < 5.1 and on_second:
        es.emitsound('player', userid_list[0], 'hl1/fvox/beep.wav', 1, 0)
        es.centermsg(int(timeleft))

    # Stop and slay the one with the lowest hp?
    if timeleft == 0.0:
        es.centermsg(0)

        p1 = getPlayer(userid_list[0])
        p2 = getPlayer(userid_list[1])
        
        x = []
        
        # Slay the one with the lower hp
        if p1.health > p2.health:
            x = [userid_list[1]]  
        elif p1.health > p1.health:
            x = [userid_list[0]] 
        
        # Slay them both
        else:
            shuffle(userid_list)
            x = userid_list
    
        # Add them to the kill list
        misc['can_kill'].extend(x)
        
        # Slay them
        delay_slay(x)
        
        clean_fight()
        return                    
                          
        
    
    ''' 
        ==========================
        > Beacon section
        ==========================
    ''' 
    
    # Beacon once a second if allowed
    if int(monday_knife_beacon) and on_second:                
        for uid in userid_list: 
            if not es.getplayerprop(uid, 'CBasePlayer.pl.deadflag'):
                team = int(es.getplayerteam(uid))
                
                # Get team colors
                if team == 3:
                    r = 0
                    b = 255
                else:
                    r = 255
                    b = 0
                    
                x, y, z = es.getplayerlocation(uid)
                
                # Draw beacon #1
                drawCircle((x, y, z + 10), radius=125, steps=12, 
                  halo='sprites/lgtning.vmt', model='sprites/lgtning.vmt', 
                  seconds=0.7, width=10, endwidth=10, red=r, green=50, blue=b)
                
                # Draw beacon #2
                drawCircle((x, y, z + 10), radius=150, steps=12, 
                  halo='sprites/lgtning.vmt', model='sprites/lgtning.vmt', 
                  seconds=1, width=10, endwidth=10, red=r, green=50, blue=b)



    ''' 
        ==========================
        > Disco ball section
        ==========================
    ''' 
    
    # Are we using the disco ball?
    if not int(monday_knife_disco):
        return
        
    # Stop here if we don't have the index of the ball
    if str(m_disco_index) in ('', '0', 'None'):
        return  
    
    # Stop here if there is a problem with the ball
    if kdisco['error']:
        return
    
    # Axis of the ball
    kdisco['axis'] = es.getindexprop(str(m_disco_index),'CBaseEntity.m_angRotation')
    
    # Make sure it came back as a string, and not something else
    if type(kdisco['axis']) != str:        
        kdisco['error'] = True       
        return
              
    # Convert str into a list
    kdisco['axis'] = list(map(float, kdisco['axis'].split(',')))

    # Get a end point for the laser (player)
    if not randint(0, 5):
        p = list(es.getplayerlocation(choice(userid_list)))        

    # Get a end point for the laser (random)
    else:
        p = [(x + (randint(50,350)*choice((-1,1)))) for x in kdisco['loc']]

    # Effects loop         
    for i in range(randint(10, 20)):
        global lasers
        lasers += 1
        # Grab set of colors
        rgb = colors()
        
        # Set destination
        p2 = [x + randint(-555, 555) for x in p] 
        
        # Draw new laser
        if randint(1,4) == 1:
            drawLine(kdisco['loc'], p2, 'sprites/lgtning.vmt', 
              'sprites/lgtning.vmt', max(random(), 0.17), 
              randint(10, 35), randint(15, 50), rgb[0], rgb[1], rgb[2], 
              randint(100, 255), 10, 0, 0, 0, 0)
        else:
            drawLine(kdisco['loc'], p2, 'materials/sprites/laser.vmt', 
              'materials/sprites/halo01.vmt', max(random(), 0.22), 
              randint(8, 35), randint(12, 50), rgb[0], rgb[1], rgb[2], 
              randint(115, 255), 10, 0, 0, 0, 0)
          
        # Move ball axis
        if i == 1:
            kdisco['axis'][1] += 12.50                    
    
        # Change smoke color every 1.5 seconds
        if not repeater['count'] % 15:
            
            # Change the smoke color for the 2nd controller
            if i == 2:
                rgb.insert(0, 2)
            
            # Change the smoke color for the main controller
            elif i == 0:
                rgb.insert(0, '')
            
            # No change is needed
            else:
                continue      

    # Move ball
    es.setindexprop(str(m_disco_index), 'CBaseEntity.m_angRotation','%d,%d,%d' % tuple(kdisco['axis']))                



# ============================================================================
# >> REPEATER
# ============================================================================

'''
    This was done for insurance, as sometimes unloads/loads with unlucky
    timing would crash a server. :(  I added the global to the end of the file
    so the function it points to is not loaded at the begining.
'''

# Does the loop already exists?
# Comments by Corvette 911
# look to see if the 'monday knife' is registered as a repeater to avoid an error
# and assign it to repeater if it does exist
repeater = repeat.find('monday_knife')
if repeater != None:
    
    # Is the loop running? Then stop it!
    if repeater.status() == 2:
        repeater.stop()
        
        userid = es.getuserid()

        # Slay all terrorists to end the round
        for userid in getUseridList('#alive, #t'):
            es.server.queuecmd('es_xsexec %s kill' % userid)
            
    # Delete the old loop
    repeater.delete()

# Delete vars
del repeater
if 'userid' in locals().keys():
    del userid
    
# Global for the loop
# Comments by Corvette 911
# repeat is a corelib function in python for eventscripts the command
# knife_loop will be repeated under the registered repeat 'monday knife'
# this is assigned to variable repeater internal to this program for simplicity
repeater = repeat.create('monday_knife', knife_loop) 